commit f150aab5e67a545824004a49277c82f66c0c4651
Author: Robert Haschke <rhaschke@techfak.uni-bielefeld.de>
Date:   Sat Nov 14 14:57:52 2020 +0100

    clang-format-10

diff --git a/server/src/main.cpp b/server/src/main.cpp
index 38c52cb..e6ce5ed 100644
--- a/server/src/main.cpp
+++ b/server/src/main.cpp
@@ -1,30 +1,30 @@
 /*
-* This file is part of hlrc_server
-*
-* Copyright(c) sschulz <AT> techfak.uni-bielefeld.de
-* http://opensource.cit-ec.de/projects/hlrc_server
-*
-* This file may be licensed under the terms of the
-* GNU General Public License Version 3 (the ``GPL''),
-* or (at your option) any later version.
-*
-* Software distributed under the License is distributed
-* on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
-* express or implied. See the GPL for the specific language
-* governing rights and limitations.
-*
-* You should have received a copy of the GPL along with this
-* program. If not, go to http://www.gnu.org/licenses/gpl.html
-* or write to the Free Software Foundation, Inc.,
-* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
-*
-* The development of this software was supported by the
-* Excellence Cluster EXC 277 Cognitive Interaction Technology.
-* The Excellence Cluster EXC 277 is a grant of the Deutsche
-* Forschungsgemeinschaft (DFG) in the context of the German
-* Excellence Initiative.
-*
-*/
+ * This file is part of hlrc_server
+ *
+ * Copyright(c) sschulz <AT> techfak.uni-bielefeld.de
+ * http://opensource.cit-ec.de/projects/hlrc_server
+ *
+ * This file may be licensed under the terms of the
+ * GNU General Public License Version 3 (the ``GPL''),
+ * or (at your option) any later version.
+ *
+ * Software distributed under the License is distributed
+ * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
+ * express or implied. See the GPL for the specific language
+ * governing rights and limitations.
+ *
+ * You should have received a copy of the GPL along with this
+ * program. If not, go to http://www.gnu.org/licenses/gpl.html
+ * or write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ *
+ * The development of this software was supported by the
+ * Excellence Cluster EXC 277 Cognitive Interaction Technology.
+ * The Excellence Cluster EXC 277 is a grant of the Deutsche
+ * Forschungsgemeinschaft (DFG) in the context of the German
+ * Excellence Initiative.
+ *
+ */
 
 #include "MiddlewareRSB.h"
 #include "MiddlewareROS.h"
@@ -39,74 +39,75 @@
 #include <boost/thread/thread.hpp>
 #include <boost/algorithm/string.hpp>
 
-Arbiter *arbiter;
+Arbiter* arbiter;
 
 using namespace std;
 using namespace boost;
 
-int main(int argc, char *argv[]) {
-    if ((argc != 5) && (argc != 6)){
-        printf("> ERROR: invalid number of parameters passed to server!\n\nusage: %s <mw_hlrc> <mw_humotion> <base scopename hlrc> <base scopename humotion> [<audio output>]  (example: %s RSB RSB /flobi1/ pulse )\n",argv[0],argv[0]);
-        printf("          audio output is optional and can be {pulse,oss,alsa,null,sndio,..}\n\n");
-        exit(EXIT_FAILURE);
-    }
+int main(int argc, char* argv[]) {
+	if ((argc != 5) && (argc != 6)) {
+		printf("> ERROR: invalid number of parameters passed to server!\n\nusage: %s <mw_hlrc> <mw_humotion> <base scopename "
+		       "hlrc> <base scopename humotion> [<audio output>]  (example: %s RSB RSB /flobi1/ pulse )\n",
+		       argv[0], argv[0]);
+		printf("          audio output is optional and can be {pulse,oss,alsa,null,sndio,..}\n\n");
+		exit(EXIT_FAILURE);
+	}
 
-    printf("> hlrc_server starting\n");
+	printf("> hlrc_server starting\n");
 
-    //fetch scope from cmd line
-    std::string scope_hlrc = argv[3];
-    std::string scope_humotion = argv[4];
+	// fetch scope from cmd line
+	std::string scope_hlrc = argv[3];
+	std::string scope_humotion = argv[4];
 
-    //fetch middleware from cmd line
-    std::string mw = argv[1];
-    to_upper(mw); //convert to uppercase
+	// fetch middleware from cmd line
+	std::string mw = argv[1];
+	to_upper(mw); // convert to uppercase
 
-    //fetch mw for humotion
-    std::string mw_humotion = argv[2];
+	// fetch mw for humotion
+	std::string mw_humotion = argv[2];
 
-    //arbiter
-    std::string sound_output = "pulse";
-    if (argc == 6){
-        sound_output = argv[5];
-    }
-    arbiter = new Arbiter(sound_output);
+	// arbiter
+	std::string sound_output = "pulse";
+	if (argc == 6) {
+		sound_output = argv[5];
+	}
+	arbiter = new Arbiter(sound_output);
 
-    //mw connection
-    Middleware *middleware;
-    if (mw == "ROS"){
-        middleware = new MiddlewareROS(arbiter, scope_hlrc);
-    }else{
-        middleware = new MiddlewareRSB(arbiter, scope_hlrc);
-    }
+	// mw connection
+	Middleware* middleware;
+	if (mw == "ROS") {
+		middleware = new MiddlewareROS(arbiter, scope_hlrc);
+	}
+	else {
+		middleware = new MiddlewareRSB(arbiter, scope_hlrc);
+	}
 
-    //human motion connection:
-    humotion::client::Client *client = new humotion::client::Client(scope_humotion, mw_humotion);
+	// human motion connection:
+	humotion::client::Client* client = new humotion::client::Client(scope_humotion, mw_humotion);
 
-    printf("> all done. hlrc server ready\n");
+	printf("> all done. hlrc server ready\n");
 
-    //send values to human motion server
-    float loop_delay = 1000.0 / 50.0; //run with 50Hz
-    boost::system_time timeout = get_system_time() + posix_time::milliseconds(loop_delay);
+	// send values to human motion server
+	float loop_delay = 1000.0 / 50.0; // run with 50Hz
+	boost::system_time timeout = get_system_time() + posix_time::milliseconds(loop_delay);
 
-    while(client->ok()){
-        middleware->tick();
+	while (client->ok()) {
+		middleware->tick();
 
-        //find correct arbitration
-        arbiter->arbitrate();
+		// find correct arbitration
+		arbiter->arbitrate();
 
-        //periodically send mouth & gaze target
-        client->update_mouth_target(arbiter->get_mouth_state());
-        client->update_gaze_target(arbiter->get_gaze_state());
-        client->send_all();
+		// periodically send mouth & gaze target
+		client->update_mouth_target(arbiter->get_mouth_state());
+		client->update_gaze_target(arbiter->get_gaze_state());
+		client->send_all();
 
-        //debug:
-        //arbiter->get_mouth_state().dump();
+		// debug:
+		// arbiter->get_mouth_state().dump();
 
-        thread::sleep(timeout);
-        timeout = get_system_time() + posix_time::milliseconds(loop_delay);
-    }
-
-    return EXIT_SUCCESS;
+		thread::sleep(timeout);
+		timeout = get_system_time() + posix_time::milliseconds(loop_delay);
+	}
 
+	return EXIT_SUCCESS;
 }
-