commit 0dc9f2f9e6e160fa94be6bfaa97499afe39275a1
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Tue Oct 10 16:40:43 2017 +0200

    Bash scripts slightly enhanced: When passing --LOG option no separator is printed to log file.

diff --git a/compiler/GCC/gccsetup.sh b/compiler/GCC/gccsetup.sh
index afb286f..2990683 100755
--- a/compiler/GCC/gccsetup.sh
+++ b/compiler/GCC/gccsetup.sh
@@ -169,8 +169,9 @@ function parseIsOption {
 # usage:      setLogFile [--option=<option>] [--quiet] <infile> <outvar>
 # arguments:  --option=<option>
 #                 Select what to do if <file> already exists.
-#                 Possible values are 'a', 'r' and 'n'.
-#                 - a: append
+#                 Possible values are 'a', 'c', 'r' and 'n'.
+#                 - a: append (starts with a separator)
+#                 - c: continue (does not insert a seperator)
 #                 - r: delete and restart
 #                 - n: no log
 #                 If no option is secified but <file> exists, an interactive selection is provided.
@@ -226,13 +227,15 @@ function setLogFile {
     fi
     # evaluate option
     case "$option" in
-      a)
+      a|c)
         if [ $quiet = false ]; then
           printInfo "appending log to $filepath\n"
         fi
-        printf "\n" >> $filepath
-        printf "######################################################################\n" >> $filepath
-        printf "\n" >> $filepath
+        if [ $option != c ]; then
+          printf "\n" >> $filepath
+          printf "######################################################################\n" >> $filepath
+          printf "\n" >> $filepath
+        fi
         ;;
       r)
         echo -n "" > $filepath
@@ -657,7 +660,7 @@ function main {
     fi
     # optionally force silent appending
     if [[ "$cmd" = "--LOG"* ]]; then
-      setLogFile --option=a --quiet "$logfile" LOG_FILE
+      setLogFile --option=c --quiet "$logfile" LOG_FILE
     else
       setLogFile "$logfile" LOG_FILE
       printf "\n"
diff --git a/compiler/compilersetup.sh b/compiler/compilersetup.sh
index 3f12665..10d4b16 100755
--- a/compiler/compilersetup.sh
+++ b/compiler/compilersetup.sh
@@ -169,8 +169,9 @@ function parseIsOption {
 # usage:      setLogFile [--option=<option>] [--quiet] <infile> <outvar>
 # arguments:  --option=<option>
 #                 Select what to do if <file> already exists.
-#                 Possible values are 'a', 'r' and 'n'.
-#                 - a: append
+#                 Possible values are 'a', 'c', 'r' and 'n'.
+#                 - a: append (starts with a separator)
+#                 - c: continue (does not insert a seperator)
 #                 - r: delete and restart
 #                 - n: no log
 #                 If no option is secified but <file> exists, an interactive selection is provided.
@@ -226,13 +227,15 @@ function setLogFile {
     fi
     # evaluate option
     case "$option" in
-      a)
+      a|c)
         if [ $quiet = false ]; then
           printInfo "appending log to $filepath\n"
         fi
-        printf "\n" >> $filepath
-        printf "######################################################################\n" >> $filepath
-        printf "\n" >> $filepath
+        if [ $option != c ]; then
+          printf "\n" >> $filepath
+          printf "######################################################################\n" >> $filepath
+          printf "\n" >> $filepath
+        fi
         ;;
       r)
         echo -n "" > $filepath
@@ -370,7 +373,7 @@ function main {
     fi
     # optionally force silent appending
     if [[ "$cmd" = "--LOG"* ]]; then
-      setLogFile --option=a --quiet "$logfile" LOG_FILE
+      setLogFile --option=c --quiet "$logfile" LOG_FILE
     else
       setLogFile "$logfile" LOG_FILE
       printf "\n"
diff --git a/ide/QtCreator/QtCreatorSetup.sh b/ide/QtCreator/QtCreatorSetup.sh
index fc5f542..9eb0d83 100755
--- a/ide/QtCreator/QtCreatorSetup.sh
+++ b/ide/QtCreator/QtCreatorSetup.sh
@@ -169,8 +169,9 @@ function parseIsOption {
 # usage:      setLogFile [--option=<option>] [--quiet] <infile> <outvar>
 # arguments:  --option=<option>
 #                 Select what to do if <file> already exists.
-#                 Possible values are 'a', 'r' and 'n'.
-#                 - a: append
+#                 Possible values are 'a', 'c', 'r' and 'n'.
+#                 - a: append (starts with a separator)
+#                 - c: continue (does not insert a seperator)
 #                 - r: delete and restart
 #                 - n: no log
 #                 If no option is secified but <file> exists, an interactive selection is provided.
@@ -226,13 +227,15 @@ function setLogFile {
     fi
     # evaluate option
     case "$option" in
-      a)
+      a|c)
         if [ $quiet = false ]; then
           printInfo "appending log to $filepath\n"
         fi
-        printf "\n" >> $filepath
-        printf "######################################################################\n" >> $filepath
-        printf "\n" >> $filepath
+        if [ $option != c ]; then
+          printf "\n" >> $filepath
+          printf "######################################################################\n" >> $filepath
+          printf "\n" >> $filepath
+        fi
         ;;
       r)
         echo -n "" > $filepath
@@ -817,7 +820,7 @@ function main {
     fi
     # optionally force silent appending
     if [[ "$cmd" = "--LOG"* ]]; then
-      setLogFile --option=a --quiet "$logfile" LOG_FILE
+      setLogFile --option=c --quiet "$logfile" LOG_FILE
     else
       setLogFile "$logfile" LOG_FILE
       printf "\n"
diff --git a/ide/idesetup.sh b/ide/idesetup.sh
index 2d3aa72..8c407b5 100755
--- a/ide/idesetup.sh
+++ b/ide/idesetup.sh
@@ -169,8 +169,9 @@ function parseIsOption {
 # usage:      setLogFile [--option=<option>] [--quiet] <infile> <outvar>
 # arguments:  --option=<option>
 #                 Select what to do if <file> already exists.
-#                 Possible values are 'a', 'r' and 'n'.
-#                 - a: append
+#                 Possible values are 'a', 'c', 'r' and 'n'.
+#                 - a: append (starts with a separator)
+#                 - c: continue (does not insert a seperator)
 #                 - r: delete and restart
 #                 - n: no log
 #                 If no option is secified but <file> exists, an interactive selection is provided.
@@ -226,13 +227,15 @@ function setLogFile {
     fi
     # evaluate option
     case "$option" in
-      a)
+      a|c)
         if [ $quiet = false ]; then
           printInfo "appending log to $filepath\n"
         fi
-        printf "\n" >> $filepath
-        printf "######################################################################\n" >> $filepath
-        printf "\n" >> $filepath
+        if [ $option != c ]; then
+          printf "\n" >> $filepath
+          printf "######################################################################\n" >> $filepath
+          printf "\n" >> $filepath
+        fi
         ;;
       r)
         echo -n "" > $filepath
@@ -370,7 +373,7 @@ function main {
     fi
     # optionally force silent appending
     if [[ "$cmd" = "--LOG"* ]]; then
-      setLogFile --option=a --quiet "$logfile" LOG_FILE
+      setLogFile --option=c --quiet "$logfile" LOG_FILE
     else
       setLogFile "$logfile" LOG_FILE
       printf "\n"
diff --git a/setup.sh b/setup.sh
index 250f1b2..29f32cf 100755
--- a/setup.sh
+++ b/setup.sh
@@ -169,8 +169,9 @@ function parseIsOption {
 # usage:      setLogFile [--option=<option>] [--quiet] <infile> <outvar>
 # arguments:  --option=<option>
 #                 Select what to do if <file> already exists.
-#                 Possible values are 'a', 'r' and 'n'.
-#                 - a: append
+#                 Possible values are 'a', 'c', 'r' and 'n'.
+#                 - a: append (starts with a separator)
+#                 - c: continue (does not insert a seperator)
 #                 - r: delete and restart
 #                 - n: no log
 #                 If no option is secified but <file> exists, an interactive selection is provided.
@@ -226,13 +227,15 @@ function setLogFile {
     fi
     # evaluate option
     case "$option" in
-      a)
+      a|c)
         if [ $quiet = false ]; then
           printInfo "appending log to $filepath\n"
         fi
-        printf "\n" >> $filepath
-        printf "######################################################################\n" >> $filepath
-        printf "\n" >> $filepath
+        if [ $option != c ]; then
+          printf "\n" >> $filepath
+          printf "######################################################################\n" >> $filepath
+          printf "\n" >> $filepath
+        fi
         ;;
       r)
         echo -n "" > $filepath
@@ -528,7 +531,7 @@ function main {
     fi
     # optionally force silent appending
     if [[ "$cmd" = "--LOG"* ]]; then
-      setLogFile --option=a --quiet "$logfile" LOG_FILE
+      setLogFile --option=c --quiet "$logfile" LOG_FILE
     else
       setLogFile "$logfile" LOG_FILE
       printf "\n"