commit bb168e084a4add7b6e9493d9c256b81886872f83
Author: Your Name <you@example.com>
Date:   Wed Jun 13 11:27:20 2018 +0200

    calib

diff --git a/client/python/test.py b/client/python/test.py
index 0d10aed..7052fe9 100644
--- a/client/python/test.py
+++ b/client/python/test.py
@@ -37,7 +37,6 @@ if __name__ == "__main__":
 
     r.set_current_emotion(RobotEmotion(RobotEmotion.SAD))
     r.set_head_animation(RobotAnimation(RobotAnimation.HEAD_SHAKE))
-    r.set_speak("test 123")
 
     g = RobotGaze()
     g.gaze_type = RobotGaze.GAZETARGET_ABSOLUTE
diff --git a/server/src/EmotionConfig.cpp b/server/src/EmotionConfig.cpp
index 9af9fb0..63d9ea9 100644
--- a/server/src/EmotionConfig.cpp
+++ b/server/src/EmotionConfig.cpp
@@ -97,13 +97,20 @@ void EmotionConfig::init_neutral(){
     mouth_override.opening_center  = 1.0;
     mouth_override.position_right  = 14.7;
     mouth_override.opening_right   = 0.0;*/
-    mouth_override.position_left   = 11.54200000000000000000;
+    /*mouth_override.position_left   = 11.54200000000000000000;
     mouth_override.opening_left    = 0; //2.412000;
     mouth_override.position_center = 12.50000000000000000;
     mouth_override.opening_center  = 0; //1.737000;
     mouth_override.position_right  = 11.5250000000000000000;
     mouth_override.opening_right   = 0;//2.412000;
-
+    */
+    
+    mouth_override.position_left   = 20;
+    mouth_override.opening_left    = 0.0;
+    mouth_override.position_center = 20;
+    mouth_override.opening_center  = 0.0;
+    mouth_override.position_right  = 20;
+    mouth_override.opening_right   = 0.0;
 
 }
 
@@ -127,13 +134,22 @@ void EmotionConfig::init_happy(){
     //eyeblink request
     gaze_override.eyeblink_request_left  = humotion::GazeState::EYEBLINK_TIME_DEFAULT;
     gaze_override.eyeblink_request_right = humotion::GazeState::EYEBLINK_TIME_DEFAULT;
-
+/*
     mouth_override.position_left   = -1+9.5;
     mouth_override.opening_left    = 0.0;
     mouth_override.position_center = 24.3;
     mouth_override.opening_center  = 7.0;
     mouth_override.position_right  = -1+10.5;
-    mouth_override.opening_right   = 0.0;
+    mouth_override.opening_right   = 0.0;*/
+  
+    mouth_override.position_left   = 18; //13.56850000000000000000;
+    mouth_override.opening_left    = 0; //.791000;
+    mouth_override.position_center = 26; //14.18400000000000000000;
+    mouth_override.opening_center  = 5;
+    mouth_override.position_right  = 18; //15.31800000000000000000;
+    mouth_override.opening_right   = 0; //2.791000;
+
+ 
 
 }
 
@@ -158,11 +174,11 @@ void EmotionConfig::init_sad(){
     gaze_override.eyeblink_request_right = 3 * humotion::GazeState::EYEBLINK_TIME_DEFAULT;
 
     //mouth:
-    mouth_override.position_left   = 13.0;
+    mouth_override.position_left   = 21.0;
     mouth_override.opening_left    = 0.0;
-    mouth_override.position_center = 6.1;
+    mouth_override.position_center = 16.0;
     mouth_override.opening_center  = 0.0;
-    mouth_override.position_right  = 13.0;
+    mouth_override.position_right  = 21.0;
     mouth_override.opening_right   = 0.0;
 }
 
@@ -187,12 +203,12 @@ void EmotionConfig::init_angry(){
     gaze_override.eyeblink_request_right = 0;
 
     //mouth:
-    mouth_override.position_left   = 20.5;
-    mouth_override.opening_left    = 10.0;
-    mouth_override.position_center = 12.3;
+    mouth_override.position_left   = 21;
+    mouth_override.opening_left    = 6.0;
+    mouth_override.position_center = 22.3;
     mouth_override.opening_center  = 0.0;
-    mouth_override.position_right  = 20.5;
-    mouth_override.opening_right   = 10.0;
+    mouth_override.position_right  = 21;
+    mouth_override.opening_right   = 6.0;
 }
 
 void EmotionConfig::init_surprised(){
@@ -217,13 +233,14 @@ void EmotionConfig::init_surprised(){
     gaze_override.eyeblink_request_right = humotion::GazeState::EYEBLINK_TIME_DEFAULT;
 
     //mouth:
-    mouth_override.position_left   = 11; //13.56850000000000000000;
-    mouth_override.opening_left    = 0; //.791000;
-    mouth_override.position_center = 13; //14.18400000000000000000;
-    mouth_override.opening_center  = 5;
-    mouth_override.position_right  = 12; //15.31800000000000000000;
-    mouth_override.opening_right   = 0; //2.791000;
+    mouth_override.position_left   = 22;
+    mouth_override.opening_left    = 0.0;
+    mouth_override.position_center = 26.0;
+    mouth_override.opening_center  = 10.0;
+    mouth_override.position_right  = 22.0;
+    mouth_override.opening_right   = 0.0;
 
+    
 }
 
 void EmotionConfig::init_fear(){
@@ -248,10 +265,10 @@ void EmotionConfig::init_fear(){
     gaze_override.eyeblink_request_right = 0;
 
     //mouth:
-    mouth_override.position_left   = 12.9;
+    mouth_override.position_left   = 14;
     mouth_override.opening_left    = 0.0;
-    mouth_override.position_center = 17.3;
-    mouth_override.opening_center  = 7.2;
-    mouth_override.position_right  = 12.9;
+    mouth_override.position_center = 21;
+    mouth_override.opening_center  = 5;
+    mouth_override.position_right  = 35.9;
     mouth_override.opening_right   = 0.0;
 }