commit a193bcf1be10e3d4dbf9096e269f5f918e080889
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed May 15 17:35:50 2019 +0200

    Removed trailing spaces in several output string in multiple unit tests.

diff --git a/unittests/periphery-lld/src/ut_alld_bq27500_v1.c b/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
index 1d32532..530f9b1 100644
--- a/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
@@ -377,7 +377,7 @@ aos_utresult_t utAlldBq27500Func(BaseSequentialStream* stream, aos_unittest_t* u
 
   chprintf(stream, "ext command: device name length...\n");
   status = bq27500_lld_ext_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_EXT_CMD_DeviceNameLength, BQ27500_LLD_EXT_CMD_READ, &original_length, 1, 0, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tdevice name length: %d \n", original_length);
+  chprintf(stream, "\t\tdevice name length: %d\n", original_length);
   if (status == APAL_STATUS_SUCCESS && original_length <= 8) {
     aosUtPassed(stream, &result);
   } else {
@@ -396,31 +396,33 @@ aos_utresult_t utAlldBq27500Func(BaseSequentialStream* stream, aos_unittest_t* u
   }
 
   chprintf(stream, "battery info std commands...\n");
-  status = bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_Temperatur, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\ttemperature: %fK (%fC) \n", (float)dst/10.0f, (float)dst/10.0f-273.5f);
+  status = bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_Temperature, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
+  chprintf(stream, "\t\ttemperature: %fK (%fC)\n", (float)dst/10.0f, (float)dst/10.0f-273.5f);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_FullAvailableCapacity, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tfull available capacity: %umAh \n", dst);
+  chprintf(stream, "\t\tfull available capacity: %umAh\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_FullChargeCapacity, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tfull charge capacity: %umAh \n", dst);
+  chprintf(stream, "\t\tfull charge capacity: %umAh\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_RemainingCapacity, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tremaining capacity: %umAh \n", dst);
+  chprintf(stream, "\t\tremaining capacity: %umAh\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_Voltage, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tvoltage: %umV \n", dst);
+  chprintf(stream, "\t\tvoltage: %umV\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_AverageCurrent, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\taverage current: %dmA \n", (int8_t)dst);
+  chprintf(stream, "\t\taverage current: %dmA\n", (int8_t)dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_AveragePower, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\taverage power: %dmW \n", (int8_t)dst);
+  chprintf(stream, "\t\taverage power: %dmW\n", (int8_t)dst);
+  status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_StateOfCharge, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
+  chprintf(stream, "\t\tstate of charge: %u%%\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_TimeToFull, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
   if (dst != (uint16_t)~0) {
-    chprintf(stream, "\t\ttime to full: %umin \n", dst);
+    chprintf(stream, "\t\ttime to full: %umin\n", dst);
   } else {
-    chprintf(stream, "\t\ttime to full: (not charging) \n", dst);
+    chprintf(stream, "\t\ttime to full: (not charging)\n", dst);
   }
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_TimeToEmpty, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
   if (dst != (uint16_t)~0) {
-    chprintf(stream, "\t\ttime to empty: %umin \n", dst);
+    chprintf(stream, "\t\ttime to empty: %umin\n", dst);
   } else {
-    chprintf(stream, "\t\ttime to empty: (not discharging) \n", dst);
+    chprintf(stream, "\t\ttime to empty: (not discharging)\n", dst);
   }
   if (status == APAL_STATUS_SUCCESS) {
     aosUtPassed(stream, &result);