commit a193bcf1be10e3d4dbf9096e269f5f918e080889
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed May 15 17:35:50 2019 +0200

    Removed trailing spaces in several output string in multiple unit tests.

diff --git a/periphery-lld/AMiRo-LLD b/periphery-lld/AMiRo-LLD
index 0182861..1473a57 160000
--- a/periphery-lld/AMiRo-LLD
+++ b/periphery-lld/AMiRo-LLD
@@ -1 +1 @@
-Subproject commit 018286168437c08c9d93afc9ffab9fcb11fd9339
+Subproject commit 1473a57f96b8bcbcac3400ca3458b7a08fed5881
diff --git a/unittests/periphery-lld/src/ut_alld_A3906_v1.c b/unittests/periphery-lld/src/ut_alld_A3906_v1.c
index 8bc308f..5cc6504 100644
--- a/unittests/periphery-lld/src/ut_alld_A3906_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_A3906_v1.c
@@ -249,7 +249,7 @@ aos_utresult_t utAlldA3906Func(BaseSequentialStream* stream, aos_unittest_t* ut)
 
   _wheelSpeedTest(stream, (ut_a3906data_t*)ut->data, WHEEL_RIGHT, DIRECTION_BACKWARD, &result);
 
-  chprintf(stream, "disable power... \n");
+  chprintf(stream, "disable power...\n");
   power_state = A3906_LLD_POWER_OFF;
   status = a3906_lld_set_power(((ut_a3906data_t*)ut->data)->driver, power_state);
   status |= a3906_lld_get_power(((ut_a3906data_t*)ut->data)->driver, &power_state);
diff --git a/unittests/periphery-lld/src/ut_alld_DW1000_v1.c b/unittests/periphery-lld/src/ut_alld_DW1000_v1.c
index 2600a7a..bfe52b1 100755
--- a/unittests/periphery-lld/src/ut_alld_DW1000_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_DW1000_v1.c
@@ -268,7 +268,7 @@ aos_utresult_t utAlldDw1000Func(BaseSequentialStream* stream, aos_unittest_t* ut
   port_DisableEXT_IRQ();
 
   setHighSpeed_SPI(false, (DW1000Driver*) ut->data);
-  chprintf(stream, "expected device ID (LS SPI): 0xDECA0130 \n");
+  chprintf(stream, "expected device ID (LS SPI): 0xDECA0130\n");
   aosThdMSleep(5);
   actual_deviceId = instancereaddeviceid();
   chprintf(stream, "actual read ID: 0x%x\n", actual_deviceId);
@@ -286,7 +286,7 @@ aos_utresult_t utAlldDw1000Func(BaseSequentialStream* stream, aos_unittest_t* ut
     if(DWT_DEVICE_ID != actual_deviceId){
       chprintf(stream, "SPI is not working or Unsupported Device ID\n");
       chprintf(stream, "actual device ID is: 0x%x\n", actual_deviceId);
-      chprintf(stream, "expected device ID: 0xDECA0130 \n");
+      chprintf(stream, "expected device ID: 0xDECA0130\n");
       aosThdMSleep(5);
     }
 
@@ -303,17 +303,17 @@ aos_utresult_t utAlldDw1000Func(BaseSequentialStream* stream, aos_unittest_t* ut
 
   reset_DW1000();
 
-  chprintf(stream, "initialise instance for DW1000 \n");
+  chprintf(stream, "initialise instance for DW1000\n");
   aosThdSleep(1);
 
   int x_init = instance_init((DW1000Driver*) ut->data) ;
 
   if (0 != x_init){
-    chprintf(stream, "init error with return value: %d \n", x_init);
+    chprintf(stream, "init error with return value: %d\n", x_init);
     aosThdSleep(1);
   }
   else {
-    chprintf(stream, "init success with return value: %d \n", x_init);
+    chprintf(stream, "init success with return value: %d\n", x_init);
     aosThdSleep(1);
   }
 
@@ -341,17 +341,17 @@ aos_utresult_t utAlldDw1000Func(BaseSequentialStream* stream, aos_unittest_t* ut
   port_EnableEXT_IRQ();
   reset_DW1000();
 
-  chprintf(stream, "initialise the configuration for UWB application \n");
+  chprintf(stream, "initialise the configuration for UWB application\n");
   aosThdSleep(1);
 
   int uwb_init = UWB_Init((DW1000Driver*) ut->data);
 
   if (0 != uwb_init){
-    chprintf(stream, "UWB config error with return value: %d \n", uwb_init);
+    chprintf(stream, "UWB config error with return value: %d\n", uwb_init);
     aosThdSleep(1);
   }
   else {
-    chprintf(stream, "UWB config success with return value: %d \n", uwb_init);
+    chprintf(stream, "UWB config success with return value: %d\n", uwb_init);
     aosThdSleep(1);
   }
 
@@ -372,21 +372,21 @@ aos_utresult_t utAlldDw1000Func(BaseSequentialStream* stream, aos_unittest_t* ut
 
   /*! RUN THE STATE MACHINE DEMO APP (RTLS) */
 
-  chprintf(stream, "initialise the State Machine \n");
+  chprintf(stream, "initialise the State Machine\n");
   aosThdSleep(2);
 
   /* Initialize UWB system with user defined configuration  */
   int uwb_init = UWB_Init((DW1000Driver*) ut->data);
 
   if (0 != uwb_init){
-    chprintf(stream, "error in UWB config with return value: %d \n", uwb_init);
+    chprintf(stream, "error in UWB config with return value: %d\n", uwb_init);
   }
   else {
-    chprintf(stream, "succeed the init of UWB config \n");
+    chprintf(stream, "succeed the init of UWB config\n");
   }
   aosThdSleep(1);
 
-  chprintf(stream, "running the RTLS demo application ... \n");
+  chprintf(stream, "running the RTLS demo application ...\n");
   aosThdSleep(1);
 
   /*! Run the localization system demo app as a thread */
diff --git a/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c b/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c
index 2158c15..06bc0df 100644
--- a/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_LTC4412_v1.c
@@ -53,7 +53,7 @@ aos_utresult_t utAlldLtc4412Func(BaseSequentialStream* stream, aos_unittest_t* u
   aos_utresult_t result = {0,0};
   uint32_t status;
 
-  chprintf(stream, "read ctrl pin... \n");
+  chprintf(stream, "read ctrl pin...\n");
   ltc4412_lld_ctrl_t ctrl;
   status = ltc4412_lld_get_ctrl((LTC4412Driver*)ut->data, &ctrl);
   if(status == APAL_STATUS_SUCCESS){
@@ -62,7 +62,7 @@ aos_utresult_t utAlldLtc4412Func(BaseSequentialStream* stream, aos_unittest_t* u
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
   }
 
-  chprintf(stream, "write ctrl pin... \n");
+  chprintf(stream, "write ctrl pin...\n");
   status = ltc4412_lld_set_ctrl((LTC4412Driver*)ut->data, LTC4412_LLD_CTRL_ACTIVE);
   status |= ltc4412_lld_get_ctrl((LTC4412Driver*)ut->data, &ctrl);
   if (status == APAL_STATUS_SUCCESS && ctrl == LTC4412_LLD_CTRL_ACTIVE) {
@@ -71,7 +71,7 @@ aos_utresult_t utAlldLtc4412Func(BaseSequentialStream* stream, aos_unittest_t* u
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
   }
 
-  chprintf(stream, "read stat pin... \n");
+  chprintf(stream, "read stat pin...\n");
   ltc4412_lld_stat_t stat;
   status = ltc4412_lld_get_stat((LTC4412Driver*)ut->data, &stat);
   if(status == APAL_STATUS_SUCCESS){
diff --git a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c
index 063d2cc..23b52c2 100644
--- a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1.c
@@ -54,7 +54,7 @@ aos_utresult_t utAlldTps6211xFunc(BaseSequentialStream* stream, aos_unittest_t*
   uint32_t status;
   tps6211x_lld_power_en_t power;
 
-  chprintf(stream, "read pin... \n");
+  chprintf(stream, "read pin...\n");
   status = tps6211x_lld_get_power_en((TPS6211xDriver*)ut->data, &power);
   if(status == APAL_STATUS_SUCCESS){
     aosUtPassed(stream, &result);
@@ -62,7 +62,7 @@ aos_utresult_t utAlldTps6211xFunc(BaseSequentialStream* stream, aos_unittest_t*
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
   }
 
-  chprintf(stream, "write pin... \n");
+  chprintf(stream, "write pin...\n");
   status = tps6211x_lld_set_power_en((TPS6211xDriver*)ut->data, TPS6211x_LLD_POWER_ENABLED);
   status |= tps6211x_lld_get_power_en((TPS6211xDriver*)ut->data, &power);
   if(status == APAL_STATUS_SUCCESS && power == TPS6211x_LLD_POWER_ENABLED){
diff --git a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c
index 2aa159b..ab8d424 100644
--- a/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_TPS6211x_v1_INA219_v1.c
@@ -55,7 +55,7 @@ aos_utresult_t utAlldTps6211xIna219Func(BaseSequentialStream *stream, aos_unitte
   tps6211x_lld_power_en_t power;
   uint32_t v_buson, v_busoff;
 
-  chprintf(stream, "read pin... \n");
+  chprintf(stream, "read pin...\n");
   status = tps6211x_lld_get_power_en(((ut_tps6211xina219data_t*)ut->data)->tps6211x, &power);
   aosThdSSleep(1);
   status |= ina219_lld_read_bus_voltage(((ut_tps6211xina219data_t*)ut->data)->ina219, &v_buson, ((ut_tps6211xina219data_t*)ut->data)->timeout);
@@ -65,7 +65,7 @@ aos_utresult_t utAlldTps6211xIna219Func(BaseSequentialStream *stream, aos_unitte
     aosUtFailedMsg(stream, &result, "0x%08X\n", status);
   }
 
-  chprintf(stream, "write pin... \n");
+  chprintf(stream, "write pin...\n");
   status = tps6211x_lld_set_power_en(((ut_tps6211xina219data_t*)ut->data)->tps6211x, TPS6211x_LLD_POWER_DISABLED);
   status |= tps6211x_lld_get_power_en(((ut_tps6211xina219data_t*)ut->data)->tps6211x, &power);
   aosThdSSleep(1);
diff --git a/unittests/periphery-lld/src/ut_alld_bq27500_v1.c b/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
index 1d32532..530f9b1 100644
--- a/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
+++ b/unittests/periphery-lld/src/ut_alld_bq27500_v1.c
@@ -377,7 +377,7 @@ aos_utresult_t utAlldBq27500Func(BaseSequentialStream* stream, aos_unittest_t* u
 
   chprintf(stream, "ext command: device name length...\n");
   status = bq27500_lld_ext_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_EXT_CMD_DeviceNameLength, BQ27500_LLD_EXT_CMD_READ, &original_length, 1, 0, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tdevice name length: %d \n", original_length);
+  chprintf(stream, "\t\tdevice name length: %d\n", original_length);
   if (status == APAL_STATUS_SUCCESS && original_length <= 8) {
     aosUtPassed(stream, &result);
   } else {
@@ -396,31 +396,33 @@ aos_utresult_t utAlldBq27500Func(BaseSequentialStream* stream, aos_unittest_t* u
   }
 
   chprintf(stream, "battery info std commands...\n");
-  status = bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_Temperatur, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\ttemperature: %fK (%fC) \n", (float)dst/10.0f, (float)dst/10.0f-273.5f);
+  status = bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_Temperature, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
+  chprintf(stream, "\t\ttemperature: %fK (%fC)\n", (float)dst/10.0f, (float)dst/10.0f-273.5f);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_FullAvailableCapacity, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tfull available capacity: %umAh \n", dst);
+  chprintf(stream, "\t\tfull available capacity: %umAh\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_FullChargeCapacity, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tfull charge capacity: %umAh \n", dst);
+  chprintf(stream, "\t\tfull charge capacity: %umAh\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_RemainingCapacity, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tremaining capacity: %umAh \n", dst);
+  chprintf(stream, "\t\tremaining capacity: %umAh\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_Voltage, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\tvoltage: %umV \n", dst);
+  chprintf(stream, "\t\tvoltage: %umV\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_AverageCurrent, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\taverage current: %dmA \n", (int8_t)dst);
+  chprintf(stream, "\t\taverage current: %dmA\n", (int8_t)dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_AveragePower, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
-  chprintf(stream, "\t\taverage power: %dmW \n", (int8_t)dst);
+  chprintf(stream, "\t\taverage power: %dmW\n", (int8_t)dst);
+  status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_StateOfCharge, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
+  chprintf(stream, "\t\tstate of charge: %u%%\n", dst);
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_TimeToFull, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
   if (dst != (uint16_t)~0) {
-    chprintf(stream, "\t\ttime to full: %umin \n", dst);
+    chprintf(stream, "\t\ttime to full: %umin\n", dst);
   } else {
-    chprintf(stream, "\t\ttime to full: (not charging) \n", dst);
+    chprintf(stream, "\t\ttime to full: (not charging)\n", dst);
   }
   status |= bq27500_lld_std_command(((ut_bq27500data_t*)ut->data)->driver, BQ27500_LLD_STD_CMD_TimeToEmpty, &dst, ((ut_bq27500data_t*)ut->data)->timeout);
   if (dst != (uint16_t)~0) {
-    chprintf(stream, "\t\ttime to empty: %umin \n", dst);
+    chprintf(stream, "\t\ttime to empty: %umin\n", dst);
   } else {
-    chprintf(stream, "\t\ttime to empty: (not discharging) \n", dst);
+    chprintf(stream, "\t\ttime to empty: (not discharging)\n", dst);
   }
   if (status == APAL_STATUS_SUCCESS) {
     aosUtPassed(stream, &result);