commit 265a3b558e887756141a01909fa2bfdf29fcb854
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Tue Nov 6 12:02:00 2018 +0100

    Introduced an UML component diagram.
    Its primary purpose is to be used by super projects.

diff --git a/doc/componentdiagrams/µRtWare.svg b/doc/componentdiagrams/µRtWare.svg
new file mode 100644
index 0000000..262e741
--- /dev/null
+++ b/doc/componentdiagrams/µRtWare.svg
@@ -0,0 +1,26 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="183px" preserveAspectRatio="none" style="width:340px;height:183px;" version="1.1" viewBox="0 0 340 183" width="340px" zoomAndPan="magnify"><defs><filter height="300%" id="fpu7jyfqrbteg" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><!--entity urt_osal.h--><ellipse cx="295" cy="37" fill="#FEFECE" filter="url(#fpu7jyfqrbteg)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="67" x="261.5" y="66.9951">urt_osal.h</text><!--entity urtware.h--><ellipse cx="179" cy="37" fill="#FEFECE" filter="url(#fpu7jyfqrbteg)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="65" x="146.5" y="66.9951">urtware.h</text><!--entity urtware.hpp--><ellipse cx="55" cy="37" fill="#FEFECE" filter="url(#fpu7jyfqrbteg)" rx="8" ry="8" style="stroke: #A80036; stroke-width: 2.0;"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="83" x="13.5" y="66.9951">urtware.hpp</text><!--entity µRtWare--><rect fill="#FEFECE" filter="url(#fpu7jyfqrbteg)" height="46.2969" style="stroke: #A80036; stroke-width: 1.5;" width="99" x="129.5" y="126"/><rect fill="#FEFECE" height="10" style="stroke: #A80036; stroke-width: 1.5;" width="15" x="208.5" y="131"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="206.5" y="133"/><rect fill="#FEFECE" height="2" style="stroke: #A80036; stroke-width: 1.5;" width="4" x="206.5" y="137"/><text fill="#000000" font-family="sans-serif" font-size="14" lengthAdjust="spacingAndGlyphs" textLength="59" x="144.5" y="158.9951">µRtWare</text><!--link urt_osal.h to µRtWare--><path d="M278.956,53.215 C259.136,72.0091 225.256,104.1364 202.503,125.7129 " fill="none" id="urt_osal.h-µRtWare" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M278.2286,42.2483 A9,9 0 0 0 289.8657 54.5233" fill="none" style="stroke: #A80036; stroke-width: 1.5;"/><!--link urtware.h to µRtWare--><path d="M179,46.268 C179,62.956 179,101.1637 179,125.7129 " fill="none" id="urtware.h-µRtWare" style="stroke: #A80036; stroke-width: 1.0;"/><!--link urtware.hpp to µRtWare--><path d="M64.3202,46.268 C83.1322,62.956 126.203,101.1637 153.876,125.7129 " fill="none" id="urtware.hpp-µRtWare" style="stroke: #A80036; stroke-width: 1.0;"/><!--
+@startuml
+skinparam componentStyle uml2
+
+interface urt_osal.h
+interface urtware.h
+interface urtware.hpp
+
+component µRtWare
+µRtWare -up-( urt_osal.h
+µRtWare -up- urtware.h
+µRtWare -up- urtware.hpp
+
+@enduml
+
+PlantUML version 1.2018.11(Sat Sep 22 18:43:53 CEST 2018)
+(GPL source distribution)
+Java Runtime: OpenJDK Runtime Environment
+JVM: OpenJDK 64-Bit Server VM
+Java Version: 1.8.0_181-8u181-b13-1ubuntu0.16.04.1-b13
+Operating System: Linux
+OS Version: 4.15.0-38-generic
+Default Encoding: UTF-8
+Language: en
+Country: US
+--></g></svg>
\ No newline at end of file
diff --git a/doc/componentdiagrams/µRtWare.uml b/doc/componentdiagrams/µRtWare.uml
new file mode 100644
index 0000000..eed76cd
--- /dev/null
+++ b/doc/componentdiagrams/µRtWare.uml
@@ -0,0 +1,35 @@
+/'
+µRtWare is a lightweight publish/subscribe middleware for real-time
+applications. It was developed as part of the software habitat for the
+Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
+
+Copyright (C) 2018..2018  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+'/
+
+@startuml
+skinparam componentStyle uml2
+
+interface urt_osal.h
+interface urtware.h
+interface urtware.hpp
+
+component µRtWare
+µRtWare -up-( urt_osal.h
+µRtWare -up- urtware.h
+µRtWare -up- urtware.hpp
+
+@enduml
+